module Value where

data Val 
    = VCon  String Val Val
    | VApp  Val Val              -- Write Assoc
    | VRec  [(String,Val)]
    | VChar Char
    | VEps  
    | VNat  Int                  -- Internal Use
    | VFCon (String,Int) [Val]   -- Internal Use
      deriving (Ord,Eq)

instance Show Val where
    show (VCon s (VRec []) VEps) = "<"++s++">"
    show (VCon s (VRec []) v2)   = "<"++s++">("++show v2++")"
    show (VCon s v1 v2)          = "<"++s++">"++show v1++"("++show v2++")"
    show (VRec rs)               = "{"++foldr1 (\x y->x++", "++y) (map (\(k,v) -> k ++ ": " ++ show v) rs) ++ "}"
    show (VApp v1 VEps)          = show v1 
    show (VApp VEps v2)          = show v2
    show (VApp v1 v2)            = show v1 ++ show v2
    show (VChar c)               = [c]
    show (VEps)                  = "$"
    show (VNat i)                = show i
    show (VFCon (s,i) vs)        = s ++ "_" ++ show i ++ show vs

                                   
